# coding: utf-8

"""
    fatcat

    Fatcat is a scalable, versioned, API-oriented catalog of bibliographic entities and file metadata.   # noqa: E501

    The version of the OpenAPI document: 0.3.1
    Contact: webservices@archive.org
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ChangelogEntry(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'index': 'int',
        'editgroup_id': 'str',
        'timestamp': 'datetime',
        'editgroup': 'Editgroup'
    }

    attribute_map = {
        'index': 'index',
        'editgroup_id': 'editgroup_id',
        'timestamp': 'timestamp',
        'editgroup': 'editgroup'
    }

    def __init__(self, index=None, editgroup_id=None, timestamp=None, editgroup=None):  # noqa: E501
        """ChangelogEntry - a model defined in OpenAPI"""  # noqa: E501

        self._index = None
        self._editgroup_id = None
        self._timestamp = None
        self._editgroup = None
        self.discriminator = None

        self.index = index
        self.editgroup_id = editgroup_id
        self.timestamp = timestamp
        if editgroup is not None:
            self.editgroup = editgroup

    @property
    def index(self):
        """Gets the index of this ChangelogEntry.  # noqa: E501

        Monotonically increasing sequence number of this changelog entry.   # noqa: E501

        :return: The index of this ChangelogEntry.  # noqa: E501
        :rtype: int
        """
        return self._index

    @index.setter
    def index(self, index):
        """Sets the index of this ChangelogEntry.

        Monotonically increasing sequence number of this changelog entry.   # noqa: E501

        :param index: The index of this ChangelogEntry.  # noqa: E501
        :type: int
        """
        if index is None:
            raise ValueError("Invalid value for `index`, must not be `None`")  # noqa: E501

        self._index = index

    @property
    def editgroup_id(self):
        """Gets the editgroup_id of this ChangelogEntry.  # noqa: E501

        Identifier of editgroup accepted/merged in this changelog entry.   # noqa: E501

        :return: The editgroup_id of this ChangelogEntry.  # noqa: E501
        :rtype: str
        """
        return self._editgroup_id

    @editgroup_id.setter
    def editgroup_id(self, editgroup_id):
        """Sets the editgroup_id of this ChangelogEntry.

        Identifier of editgroup accepted/merged in this changelog entry.   # noqa: E501

        :param editgroup_id: The editgroup_id of this ChangelogEntry.  # noqa: E501
        :type: str
        """
        if editgroup_id is None:
            raise ValueError("Invalid value for `editgroup_id`, must not be `None`")  # noqa: E501

        self._editgroup_id = editgroup_id

    @property
    def timestamp(self):
        """Gets the timestamp of this ChangelogEntry.  # noqa: E501

        Date and time when the editgroup was accpeted.   # noqa: E501

        :return: The timestamp of this ChangelogEntry.  # noqa: E501
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this ChangelogEntry.

        Date and time when the editgroup was accpeted.   # noqa: E501

        :param timestamp: The timestamp of this ChangelogEntry.  # noqa: E501
        :type: datetime
        """
        if timestamp is None:
            raise ValueError("Invalid value for `timestamp`, must not be `None`")  # noqa: E501

        self._timestamp = timestamp

    @property
    def editgroup(self):
        """Gets the editgroup of this ChangelogEntry.  # noqa: E501


        :return: The editgroup of this ChangelogEntry.  # noqa: E501
        :rtype: Editgroup
        """
        return self._editgroup

    @editgroup.setter
    def editgroup(self, editgroup):
        """Sets the editgroup of this ChangelogEntry.


        :param editgroup: The editgroup of this ChangelogEntry.  # noqa: E501
        :type: Editgroup
        """

        self._editgroup = editgroup

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChangelogEntry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
